//+------------------------------------------------------------------+
//|                                             Spread Indikator.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 0
#property indicator_plots   0

extern color LabelColor = Black;
extern string Font_style = "FixedSys";
extern int corner = 0;
extern int X_distance = 3;
extern int Y_distance = 12;

#define OBJ_NAME "SpreadIndikatorObj"

int OnInit() { ShowSpread(); return(INIT_SUCCEEDED); }
int OnCalculate (const int rates_total,      // size of the price[] array 
                 const int prev_calculated,  // bars handled on a previous call 
                 const int begin,            // where the significant data start from 
                 const double& price[]       // array to calculate 
   )
{
   ShowSpread();
   return(rates_total);
}   
 

int deinit()
{
   ObjectDelete(0,OBJ_NAME);
   return(0);
}

void ShowSpread()
{
   int spread[]; CopySpread(_Symbol,_Period,0,1,spread);
   DrawSpreadOnChart(spread[0]/MathPow(10,MathMod(_Digits,2)));
}

void DrawSpreadOnChart(double spread)
{
   string s = "Spread: "+DoubleToString(spread, 1)+" pips";
   
   if(ObjectFind(0,OBJ_NAME) < 0)
   {
      ObjectCreate(0,OBJ_NAME, OBJ_LABEL, 0, 0, 0);
      ObjectSetInteger(0,OBJ_NAME, OBJPROP_CORNER, corner);
      ObjectSetInteger(0,OBJ_NAME, OBJPROP_YDISTANCE, Y_distance);
      ObjectSetInteger(0,OBJ_NAME, OBJPROP_XDISTANCE, X_distance);
      ObjectSetString(0,OBJ_NAME,OBJPROP_TEXT,s);
      ObjectSetInteger(0,OBJ_NAME,OBJPROP_FONTSIZE,12);
      ObjectSetString(0,OBJ_NAME,OBJPROP_FONT,Font_style);
      ObjectSetInteger(0,OBJ_NAME,OBJPROP_COLOR,LabelColor);
   }
   
   ObjectSetString(0,OBJ_NAME,OBJPROP_TEXT,s);
//   WindowRedraw();
}